`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    16:30:30 07/06/2007 
// Design Name: 
// Module Name:    addr_decoder 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module addr_decoder(ADDR, SELECT_RAM, SELECT_ROM8_1, SELECT_ROM8_2,
                    SELECT_ROM4, SELECT_REGISTER16, SELECT_REGISTER32);
  input      [16:0] ADDR;
  output            SELECT_RAM;
  output            SELECT_ROM8_1;
  output            SELECT_ROM8_2;
  output            SELECT_ROM4;
  output reg [7:0]  SELECT_REGISTER16;
  output reg [3:0]  SELECT_REGISTER32;

  integer i;

  // Binaere Zerlegung des Adressraumes
  assign SELECT_RAM    = ~ADDR[16];
  assign SELECT_ROM8_1 = ADDR[16] & ~ADDR[14] & ~ADDR[13];
  assign SELECT_ROM8_2 = ADDR[16] & ~ADDR[14] & ADDR[13];
  assign SELECT_ROM4   = ADDR[16] & ADDR[14] & ~ADDR[12];

  // 4 KByte-Bereich bei 64K+16K+4K selektiert
  wire ADDR64_16_4 = ADDR[16] & ADDR[14] & ADDR[12];

  always @(*) begin
    // Einzelne Register dekodieren -- 16 Bit, jede 2. Adresse
    for (i = 0; i < 8; i = i + 1)
      SELECT_REGISTER16[i] = ADDR64_16_4 & ~ADDR[4] && (ADDR[3:1] == i);
    // Einzelne Register dekodieren -- 32 Bit, jede 4. Adresse
    for (i = 0; i < 4; i = i + 1)
      SELECT_REGISTER32[i] = ADDR64_16_4 & ADDR[4] && (ADDR[3:2] == i);
  end

endmodule
