`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   16:31:17 07/06/2007
// Design Name:   addr_decoder
// Module Name:   /home/wimi/hl/Vorl/cms_07/ise/u8_a1/tb_addr_decoder.v
// Project Name:  u8_a1
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: addr_decoder
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module tb_addr_decoder_v;

  // Inputs
  reg [16:0] ADDR;

  // Outputs
  wire SELECT_RAM;
  wire SELECT_ROM8_1;
  wire SELECT_ROM8_2;
  wire SELECT_ROM4;
  wire [7:0] SELECT_REGISTER16;
  wire [3:0] SELECT_REGISTER32;

  integer i;

  // Instantiate the Unit Under Test (UUT)
  addr_decoder uut (
    .ADDR(ADDR), 
    .SELECT_RAM(SELECT_RAM), 
    .SELECT_ROM8_1(SELECT_ROM8_1), 
    .SELECT_ROM8_2(SELECT_ROM8_2), 
    .SELECT_ROM4(SELECT_ROM4), 
    .SELECT_REGISTER16(SELECT_REGISTER16), 
    .SELECT_REGISTER32(SELECT_REGISTER32)
  );

  // Alle Signale ausgeben bei
  // Aenderung aller Signale ausser ADDR
  always @(SELECT_RAM, SELECT_ROM8_1, SELECT_ROM8_2,
           SELECT_ROM4, SELECT_REGISTER16, SELECT_REGISTER32)
    $display("ADDR=%h SELECT_RAM=%b SELECT_ROM8_1=%b SELECT_ROM8_2=%b SELECT_ROM4=%b SELECT_REGISTER16=%b SELECT_REGISTER32=%b",
             ADDR, SELECT_RAM, SELECT_ROM8_1, SELECT_ROM8_2,
             SELECT_ROM4, SELECT_REGISTER16, SELECT_REGISTER32);

  initial begin
    // Initialize Inputs
    ADDR = 0;

    // Wait 100 ns for global reset to finish
    #100;

    // Add stimulus here
    // Ueberstreiche ganzen Adressraum
    for (i = 0; i < 2**17; i = i + 1) begin
      ADDR = i; #1;
    end
    $stop;
  end

endmodule

